!****************************************************************************
!****************************************************************************
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!****************************************************************************
!****************************************************************************


!****************************************************************************
!****************************************************************************
! Codecs. DCT.
! This routine does not work !!!! This is unfinished business.
!
! (c)2001 Guillaume & Mathieu Legris.
!****************************************************************************
!****************************************************************************

.text


!****************************************************************************
! Class DCT.
!****************************************************************************
!----------------------------------------------------------------------------
! 32 bits float 8x8 IDCT.
!----------------------------------------------------------------------------
	.align	5
.global _vu_codecs_dct_idct8x8_float32
_vu_codecs_dct_idct8x8_float32:
	fmov.s	fr12,@-r15
!	nop
	fmov.s	fr13,@-r15
!	nop
	fmov.s	fr14,@-r15
!	nop
	fmov.s	fr15,@-r15
!	nop
	mov.l		r8,@-r15
!	nop
	mov.l		r9,@-r15
!	nop
	mov.l		r10,@-r15
!	nop
	mov.l		r11,@-r15
!	nop
	mov.l		r12,@-r15
!	nop
	mov.l		r13,@-r15
!	nop
	mov.l		r14,@-r15


	!
	! First pass.
	!

	fschg
	mov		r5,r11 ! Coefficients.
	fmov		@r11+,xd0 ! xf0=+W0, xf1=+W0.
	mov		r5,r9 ! Coefficients.
	fmov		@r11+,xd2 ! xf2=+W6, xf3=+W2.
	mov		r4,r8 ! Source address.
	fmov		@r11+,xd4 ! xf4=+W0, xf5=+W0.
	mov		r8,r10 ! Source address.
	fmov		@r11+,xd6 ! xf6=-W2, xf7=+W6.
	mov		#8,r14
	fmov		@r11+,xd8 ! xf8=+W0, xf9=+W0.
!	nop
	fmov		@r11+,xd10 ! xf10=+W2, xf11=-W6.
!	nop
	fmov		@r11+,xd12 ! xf12=+W0, xf13=+W0.
!	nop
	fmov		@r11+,xd14 ! xf14=-W6, xf15=-W2.
!	nop

.firstPassLoop:
	mov.l		@r10,r0
!	nop
	mov.l		@(4*4,r10),r1
!	nop
	mov.l		@(6*4,r10),r2
!	nop
	lds		r0,fpul
	mov		r1,r0
	mov.l		@(2*4,r10),r3
	float		fpul,fr0 ! x0.
	mov.l		@(1*4,r10),r4
	or			r2,r0
	mov.l		@(7*4,r10),r5
	or			r3,r0
	mov.l		@(5*4,r10),r6
	or			r4,r0
	mov.l		@(3*4,r10),r7
	or			r5,r0
	lds		r1,fpul
	or			r6,r0
	float		fpul,fr1 ! x1.
	or			r7,r0
	lds		r2,fpul

	tst		r0,r0
	float		fpul,fr2 ! x2.
	bf/s		.notNull
	 lds		r3,fpul

	fmov		xd0,dr8
	fmul		fr0,fr8 ! fr8=+W0*x0.
	add		#8*4,r8
	fmul		fr0,fr9 ! fr9=+W0*x0.

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	fmov		dr8,@-r10
!	nop
	fmov		dr8,@-r10
!	nop
	fmov		dr8,@-r10
!	nop
	fmov		dr8,@-r10

	dt			r14
	bf/s		.firstPassloop
	 add		#8*4,r10

	bra		.nextPass
	 nop

.notNull:
	float		fpul,fr3 ! x3.
	lds		r4,fpul

	float		fpul,fr4 ! x4.
	lds		r5,fpul

	float		fpul,fr5 ! x5.
	lds		r6,fpul

	float		fpul,fr6 ! x6.
	lds		r7,fpul

	float		fpul,fr7 ! x7.

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	ftrv		xmtrx,fv0

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	fmov		@r11+,xd0 ! xf0=+W1, xf1=+W7.
!	nop
	fmov		@r11+,xd2 ! xf2=+W5, xf3=+W3.
!	nop
	fmov		@r11+,xd4 ! xf4=+W3, xf5=-W5.
!	nop
	fmov		@r11+,xd6 ! xf6=-W1, xf7=-W7.
!	nop
	fmov		@r11+,xd8 ! xf8=+W5, xf9=+W3.
!	nop
	fmov		@r11+,xd10 ! xf10=+W7, xf11=-W1.
!	nop
	fmov		@r11+,xd12 ! xf12=+W7, xf13=-W1.
	fmov		dr0,dr8
	fmov		@r11+,xd14 ! xf14=+W3, xf15=-W5.
	fmov		dr2,dr10
!	nop nop

	ftrv		xmtrx,fv4
	mov		r9,r11

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	fadd		fr4,fr0
	fmov		@r11+,xd0 ! xf0=+W0, xf1=+W0.
	fsub		fr4,fr8
	fmov		@r11+,xd2 ! xf2=+W6, xf3=+W2.
	fadd		fr5,fr1
	fmov		@r11+,xd4 ! xf4=+W0, xf5=+W0.
	fsub		fr5,fr9
	fmov		@r11+,xd6 ! xf6=-W2, xf7=+W6.
	fadd		fr6,fr2
	fmov		@r11+,xd8 ! xf8=+W0, xf9=+W0.
	fsub		fr6,fr10
	fmov		@r11+,xd10 ! xf10=+W2, xf11=-W6.
	fadd		fr7,fr3
	fmov		@r11+,xd12 ! xf12=+W0, xf13=+W0.
	fsub		fr7,fr11
	fmov		@r11+,xd14 ! xf14=-W6, xf15=-W2.

	add		#8*4,r10
	fmov		dr10,@-r10
!	nop
	fmov		dr8,@-r10
!	nop
	fmov		dr6,@-r10
	dt			r14
	fmov		dr4,@-r10

	bf/s		.firstPassloop
	 add		#8*4,r10

.nextPass:


	!
	! Second pass.
	!

	mova		.OO2,r0
	fmov		@r0,fr13

	mov		#32,r1
	mov		r8,r0
	mov		r1,r2
	add		#32,r2
	mov		r2,r3
	add		#32,r3
	mov		r3,r4
	add		#32,r4
	mov		r4,r5
	add		#32,r5
	mov		r5,r6
	add		#32,r6
	mov		r6,r7
	add		#32,r7

	mov		#8,r14
.secondPassLoop:
	fschg
	fmov		@r0,fr0
!	nop
	fmov		@(r0,r4),fr1
!	nop
	fmov		@(r0,r6),fr2
!	nop
	fmov		@(r0,r2),fr3
!	nop
	fmov		@(r0,r1),fr4
!	nop
	fmov		@(r0,r7),fr5
!	nop
	fmov		@(r0,r5),fr6
!	nop
	fmov		@(r0,r3),fr7
	fschg

	ftrv		xmtrx,fv0

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	fmov		@r11+,xd0 ! xf0=+W1, xf1=+W7.
!	nop
	fmov		@r11+,xd2 ! xf2=+W5, xf3=+W3.
!	nop
	fmov		@r11+,xd4 ! xf4=+W3, xf5=-W5.
!	nop
	fmov		@r11+,xd6 ! xf6=-W1, xf7=-W7.
!	nop
	fmov		@r11+,xd8 ! xf8=+W5, xf9=+W3.
!	nop
	fmov		@r11+,xd10 ! xf10=+W7, xf11=-W1.
!	nop
	fmov		@r11+,xd12 ! xf12=+W7, xf13=-W1.
	fmov		dr0,dr8
	fmov		@r11+,xd14 ! xf14=+W3, xf15=-W5.
	fmov		dr2,dr10
!	nop nop

	ftrv		xmtrx,fv4
	mov		r9,r11

!	nop nop
!	nop nop
!	nop nop
!	nop nop

	fadd		fr4,fr0
	fmov		@r11+,xd0 ! xf0=+W0, xf1=+W0.
	fsub		fr4,fr8
	fmov		@r11+,xd2 ! xf2=+W6, xf3=+W2.
	fadd		fr5,fr1
	fmov		@r11+,xd4 ! xf4=+W0, xf5=+W0.
	fsub		fr5,fr9
	fmov		@r11+,xd6 ! xf6=-W2, xf7=+W6.
	fadd		fr6,fr2
	fmov		@r11+,xd8 ! xf8=+W0, xf9=+W0.
	fsub		fr6,fr10
	fmov		@r11+,xd10 ! xf10=+W2, xf11=-W6.
	fadd		fr7,fr3
	fmov		@r11+,xd12 ! xf12=+W0, xf13=+W0.
	fsub		fr7,fr11
	fmov		@r11+,xd14 ! xf14=-W6, xf15=-W2.
	fldi0		fr4

	fschg
	fmov		fr13,fr5
	fcmp/gt	fr0,fr4

	fmov		fr0,@r0
!	nop
	fmov		fr1,@(r0,r1)
!	nop
	fmov		fr2,@(r0,r2)
!	nop
	fmov		fr3,@(r0,r3)
!	nop
	fmov		fr8,@(r0,r4)
!	nop
	fmov		fr9,@(r0,r5)
!	nop
	fmov		fr10,@(r0,r6)
!	nop
	fmov		fr11,@(r0,r7)
	fschg

	bf/s		.secondPassloop
	 add		#4,r0


	fschg

	fmov.s	@r15+,r14
!	nop
	fmov.s	@r15+,r13
!	nop
	fmov.s	@r15+,r12
!	nop
	fmov.s	@r15+,r11
!	nop
	fmov.s	@r15+,r10
!	nop
	fmov.s	@r15+,r9
!	nop
	fmov.s	@r15+,r8
!	nop
	fmov.s	@r15+,fr15
!	nop
	fmov.s	@r15+,fr14
!	nop
	fmov.s	@r15+,fr13
!	nop
	fmov.s	@r15+,fr12
!	nop
	rts
	 nop


!
! Coefficients.
!

! W0=sqrt(1/8)=+3.53553391E-1
! W1=0.5*cos(1.PI/16)=+4.90392640E-1
! W2=0.5*cos(2.PI/16)=+4.61939766E-1
! W3=0.5*cos(3.PI/16)=+4.15734806E-1
! W5=0.5*cos(5.PI/16)=+2.77785117E-1
! W6=0.5*cos(6.PI/16)=+1.91341716E-1
! W7=0.5*cos(7.PI/16)=+9.75451610E-2

!static const float64 coeffReordered[8][8]={
!	{ +W0, +W0, +W6, +W2, +W1, +W7, +W5, +W3 },
!	{ +W0, -W0, -W2, +W6, +W3, -W5, -W1, -W7 },
!	{ +W0, -W0, +W2, -W6, +W5, +W3, +W7, -W1 },
!	{ +W0, +W0, -W6, -W2, +W7, -W1, +W3, -W5 },
!
!	{ +W0, +W0, -W6, -W2, -W7, +W1, -W3, +W5 },
!	{ +W0, -W0, +W2, -W6, -W5, -W3, -W7, +W1 },
!	{ +W0, -W0, -W2, +W6, -W3, +W5, +W1, +W7 },
!	{ +W0, +W0, +W6, +W2, -W1, -W7, -W5, -W3 }
!};

	.align 5

coefficients:
	! First matrix.
	.float +3.53553391E-1, +3.53553391E-1 ! +W0, +W0.
	.float +1.91341716E-1, +4.61939766E-1 ! +W6, +W2.
	.float +3.53553391E-1, -3.53553391E-1 ! +W0, -W0.
	.float -4.61939766E-1, +1.91341716E-1 ! -W2, +W6.
	.float +3.53553391E-1, -3.53553391E-1 ! +W0, -W0.
	.float +4.61939766E-1, -1.91341716E-1 ! +W2, -W6.
	.float +3.53553391E-1, +3.53553391E-1 ! +W0, +W0.
	.float -1.91341716E-1, -4.61939766E-1 ! -W6, -W2.

	! Second matrix.
	.float +4.90392640E-1, +9.75451610E-2 ! +W1, +W7.
	.float +2.77785117E-1, +4.15734806E-1 ! +W5, +W3.
	.float +4.15734806E-1, -2.77785117E-1 ! +W3, -W5.
	.float -4.90392640E-1, -9.75451610E-2 ! -W1, -W7.
	.float +2.77785117E-1, +4.15734806E-1 ! +W5, +W3.
	.float +9.75451610E-2, -4.90392640E-1 ! +W7, -W1.
	.float +9.75451610E-2, -4.90392640E-1 ! +W7, -W1.
	.float +4.15734806E-1, -2.77785117E-1 ! +W3, -W5.

.OO2:
	.float +5.00000000E-1 ! 0.5.
!****************************************************************************
